﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using MindFusion.Scheduling.WinForms;
using MindFusion.Scheduling;

namespace TimetableReorderResources
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();

			calendar1.CurrentView = CalendarView.Timetable;
			calendar1.TimetableSettings.Dates.Add(DateTime.Today);
			calendar1.TimetableSettings.VisibleColumns = 6;
			calendar1.GroupType = GroupType.GroupByResources;

			calendar1.Resources.Add(new Resource() { Name = "r1" });
			calendar1.Resources.Add(new Resource() { Name = "r2" });
			calendar1.Resources.Add(new Resource() { Name = "r3" });
			calendar1.Resources.Add(new Resource() { Name = "r4" });
			calendar1.Resources.Add(new Resource() { Name = "r5" });
			calendar1.Resources.Add(new Resource() { Name = "r6" });

			calendar1.TimetableColumnHeaderClick += new EventHandler<DateEventArgs>(calendar1_TimetableColumnHeaderClick);
			calendar1.MouseMove += new MouseEventHandler(calendar1_MouseMove);
			calendar1.MouseUp += new MouseEventHandler(calendar1_MouseUp);
		}

		void calendar1_TimetableColumnHeaderClick(object sender, DateEventArgs e)
		{
			if (e.Clicks > 1)
				return;
			currentPoint = calendar1.PointToClient(MousePosition);
			Resource resource = calendar1.GetResourceAt(currentPoint);
			
			if (resource != null)
				selectedResource = resource;
		}

		void calendar1_MouseMove(object sender, MouseEventArgs e)
		{
			if (selectedResource != null)
			{
				if (Distance(e.Location, currentPoint) > 4)
				{
					// start the dragging operation
					dragging = true;
					calendar1.Cursor = Cursors.Hand;
				}
			}
		}

		void calendar1_MouseUp(object sender, MouseEventArgs e)
		{
			if (dragging && selectedResource != null)
			{
				Resource target = calendar1.GetResourceAt(e.Location);
				if (target != null && target != selectedResource)
				{
					Resource t = target;
					int index = calendar1.Resources.IndexOf(selectedResource);
					calendar1.Resources[calendar1.Resources.IndexOf(target)] = selectedResource;
					calendar1.Resources[index] = t;
					calendar1.Invalidate();
				}
			}
			selectedResource = null;
			currentPoint = Point.Empty;
			dragging = false;
			calendar1.Cursor = Cursors.Default;
		}

		static double Distance(Point a, Point b)
		{
			return Math.Sqrt(Math.Pow((b.X - a.X), 2) + Math.Pow((b.Y - a.Y), 2));
		}

		private Resource selectedResource = null;
		private Point currentPoint = Point.Empty;
		bool dragging = false;
	}
}
